*HtmlTabellenParser
*Funktion HtmlTabellenParse erzeugt ein mehrdimensionales Array mit den Tabellenspalten
*Funktion GetHtmlTabellenCell holt den Inhalt einer bestimmten Cell ( Zeile / Spalte )
*Geschachtelte Tabellen werden nicht unterstuetzt
*noch <TH> einbauen
*noch Fehlertoleranz einbauen: </TABLE> </TR> </TH> </TD> darf fehlen

proc main
local tab_html_text , tab_html_arr , i , ii

**************************************************
/*
*Automatischer Test
if uppCompare( "a" , "A" ) .and. ! uppCompare( "B" , "A" )
 ? procline() , "uppCompare ok "
else
 ? procline() , "uppCompare nicht ok "
 wait
endi

if i_suchTag( "<TABLE>" , 1 , "<TABLE" , 1 ) .and. i_suchTag( "<TABLE " , 1 , "<TABLE" , 1 ) .and. ! i_suchTag( "<TABLE>" , 1 , "<TBL" , 1 )
 ? procline() , "i_suchTag ok "
else
 ? procline() , "i_suchTag nicht ok "
 wait
endi

if suchTag( "123456789</table>" , "/TABLE" ) == 10
 ? procline() , "suchTag ok "
else
 ? procline() , "suchTag nicht ok "
 wait
endi
if suchTag( "123456789</table>" , "/TBL" ) = 0
 ? procline() , "suchTag ok "
else
 ? procline() , "suchTag nicht ok "
 wait
endi

if suchTagVomEnde( "123456789</table>" , "/TABLE" ) == 10
 ? procline() , "suchTagVomEnde ok "
else
 ? procline() , "suchTagVomEnde nicht ok "
 wait
endi
if suchTagVomEnde( "123456789</table>" , "/TBL" ) = 0
 ? procline() , "suchTagVomEnde ok "
else
 ? procline() , "suchTagVomEnde nicht ok "
 wait
endi

if geheNachTag( "123456789</table>" , 10 ) == 18
 ? procline() , "geheNachTag ok "
else
 ? procline() , "geheNachTag nicht ok "
 wait
endi
if geheNachTag( "123456789</table>890123456789" , 10 ) == 18
 ? procline() , "geheNachTag ok "
else
 ? procline() , "geheNachTag nicht ok "
 wait
endi
if geheNachTag( "123456789</table boder="+chr(34)+"test"+chr(34)+" rand=1>890123456789" , 10 ) == 38
 ? procline() , "geheNachTag ok "
else
 ? procline() , "geheNachTag nicht ok "
 wait
endi

wait
*Ende Automatischer Test
*/
**************************************************

cls

tab_html_text := ansi2ascii( memoread( "test_tabelle.html" ) )

if sucheNachLinks( tab_html_text , "TABLE" ) < 1
 ? "Tabellenanfang nicht gefunden"
 retu
endi

tab_html_arr := HtmlTabellenParse( tab_html_text )

*arr_zeig( tab_html_arr )

*Anzeigen Tabellen-Element
for i := 1 to len( tab_html_arr )
 for ii := 1 to len( tab_html_arr[ i ] )
  ?? getHtmlTabellenCell( tab_html_arr , i , ii ) + "  "
 next
 ?
next

wait

retu // proc main
**********************************************************************************************************************
*Funktion HtmlTabellenParse erzeugt ein mehrdimensionales Array mit den Tabellenspalten
func HtmlTabellenParse( p_html_text )
local ret_arr := {} , startPos , endPos , inner_html_text
*? procline() , "HtmlTabellenParse"

p_html_text := alltrim( p_html_text )

*Die Tabelle muss in ein Table-tag eingeschlossen sein
startPos := suchTag( p_html_text , "TABLE" )

if startPos < 1 // Fehler
 *? procline() , "kein Table-Tag im Quell-HTML vorhanden"
 retu( ret_arr )
endi

startPos := geheNachTag( p_html_text , startPos )

endPos := suchTagVomEnde( p_html_text , "/TABLE" ) - 1

if endPos < startPos
 *? procline() , "kein passendes Table-Ende-Tag im Quell-HTML vorhanden"
 retu( ret_arr )
endi

inner_html_text := subs( p_html_text , startPos , endPos - startPos )

ret_arr := i_HtmlTabellenParse( inner_html_text ) // parst den Text zwischen <table ...> und </table>

retu( ret_arr )
**********************************************************************************************************************
*parst den Text zwischen <TABLE ...> und </TABLE>
*erzeugt ein mehrdimensionales Array mit den Tabellenspalten
func i_HtmlTabellenParse( p_html_text )
local ret_arr := {} , startPos , endPos , inner_html_text , zei_arr

*? procline() , "i_HtmlTabellenParse"

p_html_text := alltrim( p_html_text )

do while ! empty( p_html_text ) // Schleife ber die Tabellenzeilen

 startPos := suchTag( p_html_text , "TR" )

 if startPos < 1 // Fehler
  *? procline() , "kein Table-Row-Tag im Quell-HTML vorhanden"
  retu( ret_arr )
 endi

 startPos := geheNachTag( p_html_text , startPos )

 p_html_text := schneideLinksAb( p_html_text , startPos - 1 )

 endPos := suchTag( p_html_text , "/TR" ) - 1

 if endPos < startPos
  *? procline() , "kein passendes Table-Row-Ende-Tag im Quell-HTML vorhanden"
  retu( ret_arr )
 endi

 inner_html_text := subs( p_html_text , 1 , endPos )

 zei_arr := HtmlTabellenZeileParse( inner_html_text ) // Zeilen-Array holen

 ret_arr := arr_haeng_an( ret_arr , zei_arr ) // Zeilen-Array an Matrix-Array anhngen

 endPos := geheNachTag( p_html_text , endPos ) // ans Ende des </TR>-tags gehen

 p_html_text := schneideLinksAb( p_html_text , endPos - 1 ) // verarbeitete Zeile abschneiden

endd
retu( ret_arr )
**********************************************************************************************************************
*parst eine HTML-Tabellen-Zeile zwischen <TR ...> und </TR>
*liefert ein Array zurck
func HtmlTabellenZeileParse( p_html_text )
local ret_arr := {} , startPos , endPos , zell_str

*? procline() , "HtmlTabellenZeileParse"

p_html_text := alltrim( p_html_text )

do while ! empty( p_html_text ) // Schleife ber die Tabellenzellen

 startPos := suchTag( p_html_text , "TD" )

 if startPos < 1 // Fehler
  *? procline() , "kein Table-Data-Tag im Quell-HTML vorhanden"
  retu( ret_arr )
 endi

 startPos := geheNachTag( p_html_text , startPos )

 p_html_text := schneideLinksAb( p_html_text , startPos - 1 )

 endPos := suchTag( p_html_text , "/TD" ) - 1

 if endPos < 1
  *? procline() , "kein passendes Table-Data-Ende-Tag im Quell-HTML vorhanden"
  retu( ret_arr )
 endi

 zell_str := subs( p_html_text , 1 , endPos ) // Zellen-Inhalt holen

 aadd( ret_arr , zell_str ) // Zellen-Inhalt an Zeilen-Array anhngen

 endPos := geheNachTag( p_html_text , endPos ) // ans Ende des </TD>-Tags gehen

 p_html_text := schneideLinksAb( p_html_text , endPos - 1 ) // verarbeitete Zeile abschneiden

endd
retu( ret_arr )
**********************************************************************************************************************
*suchen eines Tags in dem bergebenen HTML-Text
*das Tag wird ohne einschlieende spitze Klammern angegeben
*zurckgegeben wird die Position des "<" ( 1-basiert ) des gesuchten Tags
*Position Null heit nicht gefunden
func suchTag( p_html_text , p_tag_str )
local ret_pos := 0 , html_pos := 1 , tag_pos := 1

*? procline() , "suchTag"

p_tag_str := "<" + upper( alltrim( p_tag_str ) )
do while html_pos <= len( p_html_text )
 if uppCompare( subs1( p_html_text , html_pos ) , subs1( p_tag_str , tag_pos ) )
  if i_suchTag( p_html_text , html_pos , p_tag_str , tag_pos )
   ret_pos := html_pos
exit // while
  endi
 endi
 html_pos++
endd
retu( ret_pos )
**********************************************************************************************************************
*Position nach dem aktuellen Tag suchen
*gibt eine numerische Position zurck
*Null steht fr Fehler
func geheNachTag( p_html_text , p_startPos )
local ret_pos := 0

*? procline() , "geheNachTag"

do while p_startPos <= len( p_html_text )
 p_startPos++
 if subs1( p_html_text , p_startPos ) == ">" // Tag-Ende
  ret_pos := p_startPos + 1
exit // while
 endi
 if subs1( p_html_text , p_startPos ) == chr(34) // String im Tag
  p_startPos++
  do while p_startPos <= len( p_html_text ) .and. subs1( p_html_text , p_startPos ) != chr(34) // bis zum Ende des Strings vorlaufen
   p_startPos++ // die Position muss auf dem " stehen, weil am Anfang der Schleife wieder incrementiert wird
  endd
 endi
endd
retu( ret_pos )
**********************************************************************************************************************
*suchen eines Tags in dem bergebenen HTML-Text vom Ende aus
*das Tag wird ohne einschlieende spitze Klammern angegeben
*zurckgegeben wird die Position des "<" ( 1-basiert ) des gesuchten Tags
*Position Null heit nicht gefunden
func suchTagVomEnde( p_html_text , p_tag_str )
local html_pos := len( p_html_text ) - 2 // ich gehe davon aus, da ein Tag aus mindestens <*> ( 3 Zeichen ) besteht
local ret_pos := 0 , tag_pos := 1

*? procline() , "suchTagVomEnde"

p_tag_str := "<" + upper( alltrim( p_tag_str ) )
do while html_pos > 0
 if uppCompare( subs1( p_html_text , html_pos ) , subs1( p_tag_str , tag_pos ) )
  if i_suchTag( p_html_text , html_pos , p_tag_str , tag_pos )
   ret_pos := html_pos
exit // while
  endi
 endi // uppCompare
 html_pos--
 tag_pos := 1
endd
retu( ret_pos )
**********************************************************************************************************************
*innere Funktion fr suchTag
*weitersuchen falls erstes Zeichen stimmte
*die inkrementierten Positionen bleiben lokal ( auf Stack ) wodurch die Positionen in der aufrufenden Routine erhalten bleiben
*zurck geliefert wird logisch ja/nein
*es wird impliziert, da nach dem Tag-String ein Leerzeichen ( Tag mit Optionen ) oder ein > folgt
static func i_suchTag( p_html_text , p_html_pos , p_tag_str , p_tag_pos )

*? procline() , "i_suchTag" , p_html_text , p_html_pos , p_tag_str , p_tag_pos
*wait

do while p_html_pos <= len( p_html_text ) .and. p_tag_pos <= len( p_tag_str )
 if ! uppCompare( subs1( p_html_text , p_html_pos ) , subs1( p_tag_str , p_tag_pos ) )
  retu( .f. )
 endi
 *? procline() , p_html_pos , len( p_html_text ) , p_tag_pos , len( p_tag_str )
 p_html_pos++
 p_tag_pos++
endd
*? procline() , "Schleife durch"
if ( ! uppCompare( subs1( p_html_text , p_html_pos ) , " " ) ) .and. ( ! uppCompare( subs1( p_html_text , p_html_pos ) , ">" ) )
 retu( .f. )
endi
retu( .t. )
**********************************************************************************************************************
*Abschneiden einer Anzahl Zeichen von einem String links
func schneideLinksAb( p_text , p_anz )
retu( subs( p_text , p_anz + 1 ) )
**********************************************************************************************************************
*Anhngen eines Arrays an ein Array
* im Gegensatz zu aadd ist das angehngte Array nur ein Eintrag im Original-Array
func arr_haeng_an( p_arr , add_arr )
aadd( p_arr , NIL )
p_arr[ len( p_arr ) ] := add_arr
retu( p_arr )
**********************************************************************************************************************
*Substring auf nur ein Zeichen
*substring( str , pos , 1 )
func subs1( p_str , p_pos )
retu( subs( p_str , p_pos , 1 ) )
**********************************************************************************************************************
*Vergleich nicht case-sensitive
*erst beide zu vergleichenden Strings uppern und dann vergleichen
func uppCompare( p_str1 , p_str2 )
*? procline() , "uppCompare" , p_str1 , p_str2
if p_str1 == ""
 retu( .f. )
endi
retu( upper( p_str1 ) == upper( p_str2 ) ) // kein verkrzter Vergleich
**********************************************************************************************************************
*Anzeige Array zum Debugging
func arr_zeig( zeig_var , pre )
local i
if valtype( pre ) = "U"
 pre := ""
endi
if valtype( zeig_var ) = "A"
 for i=1 to len( zeig_var )
  arr_zeig( zeig_var[ i ] , "A"+strzero(i,3)+":" )
 next
else
 ? pre + valtype( zeig_var ) + ": " , zeig_var
endi
retu(NIL)
**********************************************************************************************************************
*Holen eines Tabellen(Array)-Elements
*Zeilen und Spalten 1-basiert
*Rckgabe String
func getHtmlTabellenCell( p_html_arr , p_zei , p_spa )
local ret_str := "" , t_arr

if valtype( p_html_arr ) == "A" .and. len( p_html_arr ) >= p_zei .and. p_zei > 0
 t_arr := p_html_arr[ p_zei ]
 if valtype( t_arr ) == "A" .and. len( t_arr ) >= p_spa .and. p_spa > 0
  ret_str := t_arr[ p_spa ]
 endi
endi
retu( ret_str )
**********************************************************************************************************************
*Absuchen eines Strings nach einem Tag von einer bestimmten Position an rckwrts
* wenn nicht gefunden Return Null
* sucheNachLinks( zu durchsuchender String , gesuchtes Tag ohne < , Startposition )
func sucheNachLinks( p_str , such_tag , p_pos )
such_tag := "<" + upper( alltrim( such_tag ) )
p_str := upper( p_str )
retu( rat( such_tag , p_str , p_pos ) )
**********************************************************************************************************************
*String von ASCII-Code zu ANSI-Code umwandeln
func ascii2ansi(str)
local i,t:="",t1
for i=1 to len(str)
 t1=subs(str,i,1)
 do case
 case t1=""
  t1=""
 case t1=""
  t1=""
 case t1=""
  t1=""
 case t1=""
  t1=""
 case t1=""
  t1=""
 case t1=""
  t1=""
 case t1=""
  t1=""
 endc
 t+=t1
next
retu(t)
**********************************************************************************************************************
*String von ANSI-Code zu ASCII-Code umwandeln
func ansi2ascii(str)
local i,t:="",t1
for i=1 to len(str)
 t1=subs(str,i,1)
 do case
 case t1=""
  t1=""
 case t1=""
  t1=""
 case t1=""
  t1=""
 case t1=""
  t1=""
 case t1=""
  t1=""
 case t1=""
  t1=""
 case t1=""
  t1=""
 endc
 t+=t1
next
retu(t)
**********************************************************************************************************************
